package pl.alx.kurs.bazydanych;

import android.app.Activity;
import android.content.ContentValues;
import android.content.Intent;
import android.database.ContentObserver;
import android.database.Cursor;
import android.database.DataSetObserver;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Looper;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;

public class Osoby extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		setContentView(R.layout.osoby);
		new AsyncTask<Void, Void, Cursor>() {
			@Override
			protected Cursor doInBackground(Void... params) {
				Cursor kursor = getContentResolver().query(Uri.parse("content://pl.alx.kurs.bazydanych.provider/osoby"), null, null, null, null);
				kursor.registerContentObserver(new ContentObserver(null) {
					public void onChange(boolean selfChange) {
						Log.i("test", "ContentObserver, onChange. " + (Looper.myLooper() == Looper.getMainLooper() ? "" : "nie") + " jestem w gwnym wtku");
					};
				});
				kursor.registerDataSetObserver(new DataSetObserver() {
					public void onChanged() {
						Log.i("test", "DataSetObserver, onChanged. " + (Looper.myLooper() == Looper.getMainLooper() ? "" : "nie") + " jestem w gwnym wtku");
					};
				});
				return kursor;
			}
			@Override
			protected void onPostExecute(Cursor kursor) {
				startManagingCursor(kursor);
				SimpleCursorAdapter adapter = new SimpleCursorAdapter(Osoby.this, android.R.layout.simple_list_item_2, kursor, new String[]{"imie", "nazwisko"}, new int[]{android.R.id.text1, android.R.id.text2});
				((ListView) findViewById(R.id.osoby)).setAdapter(adapter);
			}
		}.execute();
		((ListView) findViewById(R.id.osoby)).setOnItemLongClickListener(new AdapterView.OnItemLongClickListener() {
			public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {
				Intent i = new Intent(Intent.ACTION_VIEW);
				Uri uri = Uri.parse("content://pl.alx.kurs.bazydanych.provider/osoba/" + id);
				i.setData(uri);
				startActivity(i);
				return true;
			}
		});
		super.onCreate(savedInstanceState);
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add(0, 3, 3, "dodaj osob");
		return super.onCreateOptionsMenu(menu);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		if (item.getItemId() == 3) {
			ContentValues values = new ContentValues();
			values.put("imie", "Jan" + Math.round(Math.random() * 100));
			values.put("nazwisko", "X " + Math.round(Math.random() * 100));
			values.put("waga", Math.round(Math.random() * 50) + 50);
			values.put("wzrost", 1 + Math.random());
			getContentResolver().insert(Uri.parse("content://pl.alx.kurs.bazydanych.provider/osoby"), values);
		}
		return false;
	}
}
